const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const partners = sequelize.define(
    'partners',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

partner_name: {
        type: DataTypes.TEXT,
      
      

      },

partner_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"referral",


"reseller",


"agency",


"platform"

        ],

      },

contact_email: {
        type: DataTypes.TEXT,
      
      

      },

contact_phone: {
        type: DataTypes.TEXT,
      
      

      },

is_active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  partners.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity



























    db.partners.hasMany(db.tenant_partnerships, {
      as: 'tenant_partnerships_partner',
      foreignKey: {
          name: 'partnerId',
      },
      constraints: false,
    });


    db.partners.hasMany(db.payouts, {
      as: 'payouts_partner',
      foreignKey: {
          name: 'partnerId',
      },
      constraints: false,
    });






//end loop



    db.partners.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.partners.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.partners.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return partners;
};


